from h5schemas.scan_schema import GroupDefinition
from h5schemas.h5_types.base_dataset import BaseDataset
import h5py

STRING_SIZE = 100


class StringDataset(BaseDataset):
    dtype = f"S{STRING_SIZE}"

    def __init__(self, definition: GroupDefinition):
        super().__init__(definition)

    def add_to_file(self, h5_file: h5py.File):
        group = h5_file.require_group(self.group)
        self.dataset = group.create_dataset(
            name=self.dataset_name,
            shape=(0,),
            dtype=self.dtype,
            chunks=True,
            maxshape=(None,),
        )
